# Contributing

Thank you for investing your time in contributing to our project! :sparkles:. 

Read our [Code of Conduct](./CODE_OF_CONDUCT.md) to keep our community approachable and respectable.

In this guide you will get an overview of the contribution workflow from opening an issue, creating a PR, reviewing, and merging the PR.

## Getting started

### Issues

#### Create a new issue

If you spot a problem, search if an issue already exists. If a related issue doesn't exist, you can open a new issue using a relevant issue form.

#### Solve an issue

Scan through our [existing issues](https://github.com/c9s/bbgo/issues) to find one that interests you.
You can narrow down the search using `labels` as filters. As a general rule, we don’t assign issues to anyone.
If you find an issue to work on, you are welcome to open a PR with a fix.

### Making Changes

For new large features, such as integrating binance futures contracts, please propose a discussion first before you start working on it.

For new small features, you could open a pull request directly.

For each contributor, you have chance to receive the BBG token through the polygon network.

Each issue has its BBG label, by completing the issue with a pull request, you can get correspond amount of BBG.

## Support

### By contributing pull requests

Any pull request is welcome, documentation, format fixing, testing, features.

### By registering account with referral ID

You may register your exchange account with my referral ID to support this project.

- For MAX Exchange: <https://max.maicoin.com/signup?r=c7982718> (default commission rate to your account)
- For Binance Exchange: <https://www.binancezh.com/en/register?ref=VGDGLT80> (5% commission back to your account)

### By small amount cryptos

- BTC address `3J6XQJNWT56amqz9Hz2BEVQ7W4aNmb5kiU`
- USDT ERC20 address `0xeBcf7887A5b767DEb2e0C77E46A22c6Adc64E427`
- USDT POLYGON address `0xeBcf7887A5b767DEb2e0C77E46A22c6Adc64E427`

### Buying BBG token

BBGO issued a token BBG for the ecosystem (contract
address: <https://etherscan.io/address/0x3afe98235d680e8d7a52e1458a59d60f45f935c0> on ethereum).

If you have feature request, you can offer your BBG for contributors.

BBG/ETH liquidity pool on Uniswap: <https://app.uniswap.org/#/pool/28377>

BBG/MATIC pool on quickswap: https://quickswap.exchange/#/swap?outputCurrency=0x3Afe98235d680e8d7A52e1458a59D60f45F935C0

For further request, please contact us: <https://t.me/c123456789s>

## Community

You can join our telegram channels:

- BBGO International <https://t.me/bbgo_intl>
- BBGO Taiwan <https://t.me/bbgocrypto>

